#include "planar_quadrotor_visualizer.h"

PlanarQuadrotorVisualizer::PlanarQuadrotorVisualizer(PlanarQuadrotor *quadrotor_ptr): quadrotor_ptr(quadrotor_ptr) {}

/**
 * TODO: Improve visualizetion
 * 1. Transform coordinates from quadrotor frame to image frame so the circle is in the middle of the screen
 * 2. Use more shapes to represent quadrotor (e.x. try replicate http://underactuated.mit.edu/acrobot.html#section3 or do something prettier)
 * 3. Animate proppelers (extra points)
 */
void PlanarQuadrotorVisualizer::render(std::shared_ptr<SDL_Renderer> &gRenderer, const int SCREEN_HEIGHT, const int SCREEN_WIDTH) {
    Eigen::VectorXf state = quadrotor_ptr->GetState();
    float q_x, q_y, q_theta;
    int length=110, dist=90, high=50;
    const int k = 20, prop_len = 30;
    /* x, y, theta coordinates */
    q_x = state[0]+SCREEN_WIDTH/2;
    q_y = state[1]+SCREEN_HEIGHT/2;
    q_theta = state[2]/2;

    float phi = q_x - SCREEN_WIDTH;

    static int check=1;
    phi+=370*check;
    check*=-1;

    
    SDL_SetRenderDrawColor(gRenderer.get(), 0xFF, 0x00, 0x00, 0xFF);
    thickLineColor(gRenderer.get(), q_x-(length+2)*cos(q_theta), q_y+(length+2)*sin(q_theta), q_x+(length+2)*cos(q_theta), q_y-(length+2)*sin(q_theta), 24, 0xFF000000); //obramówka
    thickLineColor(gRenderer.get(), q_x-length*cos(q_theta), q_y+length*sin(q_theta), q_x+length*cos(q_theta), q_y-length*sin(q_theta), 20, 0xFF999999); //belka
    thickLineColor(gRenderer.get(), q_x-dist*cos(q_theta), q_y+dist*sin(q_theta), q_x-dist*cos(q_theta)-high*sin(q_theta), q_y+dist*sin(q_theta)-high*cos(q_theta), 5, 0x99333399); //pion L
    thickLineColor(gRenderer.get(), q_x+dist*cos(q_theta), q_y-dist*sin(q_theta), q_x+dist*cos(q_theta)-high*sin(q_theta), q_y-dist*sin(q_theta)-high*cos(q_theta), 5, 0x99333399); //pion P
    filledEllipseColor(gRenderer.get(),  q_x-dist*cos(q_theta)-high*sin(q_theta)-prop_len+prop_len*abs(sin(phi)),  q_y+dist*sin(q_theta)-high*cos(q_theta),  prop_len,  8,  0xFFFF0000);
    filledEllipseColor(gRenderer.get(),  q_x-dist*cos(q_theta)-high*sin(q_theta)+prop_len-prop_len*abs(sin(phi)),  q_y+dist*sin(q_theta)-high*cos(q_theta),  prop_len,  8,  0xFFFF0000);
    filledEllipseColor(gRenderer.get(),  q_x+dist*cos(q_theta)-high*sin(q_theta)-prop_len+prop_len*abs(sin(phi-3.14)),  q_y-dist*sin(q_theta)-high*cos(q_theta),  prop_len,  8,  0xFFFF0000);
    filledEllipseColor(gRenderer.get(),  q_x+dist*cos(q_theta)-high*sin(q_theta)+prop_len-prop_len*abs(sin(phi-3.14)),  q_y-dist*sin(q_theta)-high*cos(q_theta),  prop_len,  8,  0xFFFF0000);
}