#include <string>
#include <SDL.h>
#include "player.h"

Player::Player(std::string path){
    SDL_LoadWAV(path.c_str(), &spec, &audio_buf, &audio_len);
}

Player::~Player(){
    SDL_FreeWAV(audio_buf);
    SDL_CloseAudioDevice(dev);
}

void Player::Device(){
    dev = SDL_OpenAudioDevice(nullptr, 0, &spec, nullptr, SDL_AUDIO_ALLOW_CHANNELS_CHANGE );
}

void Player::Play(){
    int status = SDL_QueueAudio(dev, audio_buf, audio_len);
    SDL_PauseAudioDevice(dev,0);
}

void Player::Stop(){
    SDL_PauseAudioDevice(dev,1);
}

int Player::IsPlaying(){
    return SDL_GetAudioDeviceStatus(dev);
}
